﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;

namespace WindowsFormsApplication3
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            this.ultraGrid1.CreationFilter = new MyCreationFilter();
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            if (false == e.Layout.Bands[1].Columns.Exists("Placeholder"))
            {
                UltraGridColumn placeholderColumn = e.Layout.Bands[1].Columns.Add("Placeholder");
                int width = 0;
                foreach (UltraGridColumn column in e.Layout.Bands[1].Columns)
                {
                    if (column == placeholderColumn)
                        continue;

                    width += column.Width;
                }
                placeholderColumn.Width = width;
            }

            e.Layout.AutoFitStyle = Infragistics.Win.UltraWinGrid.AutoFitStyle.ResizeAllColumns;
            e.Layout.Override.BorderStyleRow = Infragistics.Win.UIElementBorderStyle.None;
        }
    }
        
    public class MyCreationFilter : Infragistics.Win.IUIElementCreationFilter   
    {
        #region IUIElementCreationFilter Members

        void Infragistics.Win.IUIElementCreationFilter.AfterCreateChildElements(Infragistics.Win.UIElement parent)
        {
            UltraGridColumn column = parent.GetContext(typeof(UltraGridColumn)) as UltraGridColumn;
            if (column == null)
            {
                UltraGridCell cell = parent.GetContext(typeof(UltraGridCell)) as UltraGridCell;
                if (cell != null)
                    column = cell.Column;
            }

            if (column != null && column.Key == "Placeholder")
            {
                parent.Parent.ChildElements.Remove(parent);
            }
        }

        bool Infragistics.Win.IUIElementCreationFilter.BeforeCreateChildElements(Infragistics.Win.UIElement parent)
        {
            return false;
        }

        #endregion
    }

}
